#include "AnalizaAmplitudev00.h"


//////////////////////////////////////////////////////////
//
//         a_amplitude
//
//////////////////////////////////////////////////////////


analisa::a_amplitude(int nevents) {

  //Filename variables
  const char *iname,*oname,*disp;

  //Reset ROOT and connect tree file
  gROOT->Reset();

  //cout << "\nEnter name of output file:\n";
  //cin.getline (oname,50);
  //cout << "\nDisplay event graphs (y/n):\n";
  //cin.getline (disp,50);

  //TFile fileopen(iname,"RECREATE");
  //oname=strcmp("res.",iname);
  // fTxt1->nevents;

  //cout << "iname = " << iname << "\noname = " << oname << "\n\n";
  
  //TFile *file = (TFile*)gROOT->FindObject(iname);
  //if (file) {
  //  // file already connected
  //} else {
  //  // file not yet connected
  //  // open file
  //  file = new TFile(iname);
  //}

  //iname="fc1.dat.root";
  TFile* myfile = new TFile(iname); 


  //TFile *iname=(TFile*)gDirectory->GetFile(iname);

  cout << "Input Filename: " << iname << endl;

  oname=strcmp("res.",iname);

  TTree *AR = (TTree*)gDirectory->Get("AR");
  
  const Float_t avgdeltae=2.335;
  const Float_t sigmadeltae=1.004;

  //Set branch addresses
  AR->SetBranchAddress("NChannel",&nChannel);
  AR->SetBranchAddress("Signal",signal);
  AR->SetBranchAddress("NPeaks",&npeaks);
  AR->SetBranchAddress("Tmed",Tmed);
  AR->SetBranchAddress("SigmaT",SigmaT);
  AR->SetBranchAddress("Peak",Peak);
  AR->SetBranchAddress("PeakSum",PeakSum);
  AR->SetBranchAddress("TTrigger",TTrigger);
  AR->SetBranchAddress("DeltaT",DeltaT);
  AR->SetBranchAddress("TotalSum",&sum);
  
  
  // open canvas
  TCanvas *c = new TCanvas("c","MIP Graphs",10,10,900,900);
  //pads 
  pad1 = new TPad("pad1","canal 1",0.03,0.61,0.49,0.90,21);
  pad2 = new TPad("pad2","canal 2",0.03,0.31,0.49,0.60,21);
  pad3 = new TPad("pad3","canal 3",0.03,0.01,0.49,0.30,21);
  pad4 = new TPad("pad4","canal 4",0.51,0.61,0.97,0.90,21);
  pad5 = new TPad("pad5","canal 5",0.51,0.31,0.97,0.60,21);
  pad6 = new TPad("pad6","canal 6",0.51,0.01,0.97,0.30,21);
  pad1->Draw();
  pad2->Draw();
  pad3->Draw();
  pad4->Draw();
  pad5->Draw();
  pad6->Draw();

  // get entries
  Int_t nentries_AR = AR->GetEntries();

  // book histograms
  TH1F *hsig = new TH1F("hsig","event Signal",256,0.,255.);   
  TH1F *hsig1 = new TH1F("hsig1","event Signal",30,115.,165.);   

  TAxis *axis = hsig->GetXaxis();//defines axis
  TAxis *axis1 = hsig1->GetXaxis();

  hsig->SetMaximum(500.);//defines graph limits
  hsig->SetMinimum(0.);
  hsig1->SetMaximum(500.);
  hsig1->SetMinimum(0.);

  // set hist attributes 
  hsig->SetFillStyle(1000);
  hsig->SetFillColor(7);
  hsig1->SetFillStyle(1000);
  hsig1->SetFillColor(2);

  // initializes 
  //Int_t ij=1;
  //Int_t ch1=0; //activated channels
  //Int_t ch2=1;
  //Int_t ch3=3;

  TFile *fitres_file1=new TFile(oname,"RECREATE");
  
  cout << "\n\nwrote to" << oname << "\n\n";

  //save fit results
  TTree *fitres = new TTree("FitRes","Fit Results");
  fitres->Branch("event",&fr.nev,"nev/I");
  fitres->Branch("channel",fr.nch,"nch[6]/I");
  fitres->Branch("npks",fr.npks,"npks[6]/I");
  fitres->Branch("chi2",fr.chi2,"chi2[6]/F");
  fitres->Branch("dof",fr.dof,"dof[6]/F");
  fitres->Branch("A",fr.a,"a[6]/F");
  fitres->Branch("xo",fr.xo,"xo[6]/F");
  fitres->Branch("delta",fr.delta,"delta[6]/F");
  fitres->Branch("omega",fr.omega,"omega[6]/F");
  fitres->Branch("area",fr.area,"area[6]/F");
  fitres->Branch("xmed",fr.xmed,"xmed[6]/F");
  fitres->Branch("sigmax",fr.sx,"sx[6]/F");
  fitres->SetAutoSave(10000);

  //title 
  //title = new TPaveLabel(0.1,0.94,0.9,0.98,Form("Event Signal %d ",i)); //creates and writes the title in the window
  //title->Draw();
  TPaveText pave(0.1,0.94,0.9,0.98);

  // loop on events
  Int_t nbytes_AR = 0;
  Int_t nloop = nentries_AR/6;
  //   for (Int_t i=1; i<=nloop;i++) {
  for (int i=1; i<=nevents; i++) {

    //getchar();

    cout << " ***************************** event number = " << i << endl;
    cout << "\n";

    //title = new TPaveLabel(0.1,0.94,0.9,0.98);//,Form("Event Signal %d ",i)); //creates and writes the title in the window
    //title.Draw(Form("Event Signal %d ",i));//Form("Event Signal %d ",i));
 
    //TPaveText pave(0.1,0.94,0.9,0.98);
      pave.Clear();
      pave.InsertLine();
      pave.InsertText(Form("Event Signal %d ",i));
      pave.Draw();
     
    
    for (Int_t nc=0; nc<6 ; nc++) {
      Int_t np = (i-1)*6 + nc; 
      nbytes_AR += AR->GetEntry(np); //gets the signal
      hsig->Reset();
      hsig1->Reset();
      
      
      for (Int_t j=0; j<256; j++) { //above threshold 
	if(signal[j]>-1.) {
	  hsig->Fill(j+0.5,signal[j]);
	  hsig1->Fill(j+0.5,signal[j]);
	}
      } 
      cout << "channel " << nChannel << endl;
   
      switch (nChannel) {
      case 0: 
	pad1->cd();
	pad1->GetFrame()->SetFillColor(18);
	hsig1->SetFillColor(2);
	hsig1->Draw();
	hsig1->SetTitle("Ch 1");
	hsig1->GetYaxis()->SetTitle("  Event Signal ");
	break;  
      case 1: 
	pad2->cd();
	pad2->GetFrame()->SetFillColor(18);
	hsig1->SetFillColor(2);
	hsig1->Draw();
	hsig1->SetTitle("Ch 2");
	hsig1->GetYaxis()->SetTitle("  Event Signal ");
	break;  
      case 2: 
	pad3->cd();
	pad3->GetFrame()->SetFillColor(18);
	hsig1->SetFillColor(2);
	hsig1->Draw();
	hsig1->SetTitle("Ch 3");
	hsig1->GetYaxis()->SetTitle("  Event Signal "); 
	break;  
      case 3: 
	pad4->cd();
	pad4->GetFrame()->SetFillColor(18);
	hsig1->SetFillColor(2);
	hsig1->Draw();
	hsig1->SetTitle("Ch 4");
	hsig1->GetYaxis()->SetTitle("  Event Signal ");
	break;  
      case 4: 
	pad5->cd();
	pad5->GetFrame()->SetFillColor(18);
	hsig1->SetFillColor(2);
	hsig1->Draw();
	hsig1->SetTitle("Ch 5");
	hsig1->GetYaxis()->SetTitle("  Event Signal ");
	break;  
      case 5: 
	pad6->cd();
	pad6->GetFrame()->SetFillColor(18);
	hsig1->SetFillColor(2);
	hsig1->Draw();
	hsig1->SetTitle("Ch 6");
	hsig1->GetYaxis()->SetTitle("  Event Signal ");
	break;  
      }
      
      
      //fit cycle
      
      //trigger
      trigger=4;
      
      //start analysis variables
      xo=ttrigger=peak=tpeak=deltat=npeaks=0;
      
      //start fit parameters
      
      fr.npks[nc]=0;
      fr.chi2[nc]=fr.dof[nc]=fr.a[nc]=fr.xo[nc]=fr.delta[nc]=fr.omega[nc]=fr.k[nc]=0; 

      //start peak data
      fr.area[nc]=fr.xmed[nc]=fr.sx[nc]=0;
      
      /*    get signal from tree
		 b_Signal->GetEntry(nevt*6+i); */
      
      //baseline estimation
      bl = 0.;

      for(j=0; j<10; j++) {
	bl = bl+signal[j];
      }

      bl = bl*0.1+4.;

      //search a peak on signal
      for(j=0; j<256; j++) {
	if(npeaks==0) {
	  //add start signal channel
	  if(signal[j] > bl) xo=j+0.5;
	  
	  //trigger for analysis
	  if(signal[j] >=trigger+bl) {   //<---------trigger substitui por trigger+bl
	    //peak flag
	    fr.npks[nc]=npeaks=1;
	    
	    //set time of trigger
	    ttrigger=j+0.5;
	    
	    //start peak data
	    tpeak=ttrigger;
	    peak=signal[j];
	    
	    //search for signal peak
	    while(signal[j] > bl) {
	      if(signal[j] > peak) {
		tpeak=j+0.5;
		peak=signal[j];
	      }
	      j++;
	    }
	  }
	}
      }
      
      //distance from signal start to peak
      deltat=tpeak-xo;
      
      if(npeaks!=0 && xo>100.) {
	
	
	//set functional form - logarithmic gaussian
	TF1 *logG = new TF1("logG",
			    "[0]*exp(-0.5*pow(log((x-[1])/[2])/[3],2))+[4]",
			    xo,xo+10);
	logG->SetParNames("a","xo","delta","omega","k");
	logG->SetParameters(peak,xo,deltat,0.7,1.); 
	logG->SetParLimits(0,peak-2,peak+2);
	logG->SetParLimits(1,xo-1,xo+1);
	logG->SetParLimits(2,0.01,5.);
	logG->SetParLimits(3,0.,10.);
	logG->SetParLimits(4,0.,30.);

	//fit functional form to data
	hsig1->Fit("logG","QRWBN0","",xo,xo+10); 
	
	//get fit results
	fr.chi2[nc]=logG->GetChisquare();
	fr.dof[nc]=logG->GetNDF();
	fr.a[nc]=logG->GetParameter(0);
	fr.xo[nc]=logG->GetParameter(1);
	fr.delta[nc]=logG->GetParameter(2);
	fr.omega[nc]=logG->GetParameter(3);
	fr.k[nc]=logG->GetParameter(4);
	

	//signal area
	fr.area[nc]=fr.a[nc]*fr.delta[nc]*exp(0.5*pow(fr.omega[nc],2));
	fr.area[nc]*=sqrt(2*3.1416)*fr.omega[nc];
	
	//average time
	fr.xmed[nc]=fr.delta[nc]*exp(1.5*pow(fr.omega[nc],2));
        
	//time rms
	fr.sx[nc]=fr.xmed[nc]*sqrt(exp(pow(fr.omega[nc],2))-1);
	
	//print fit results
	cout << "chi2=" <<fr.chi2[nc] << "   dof=" << fr.dof[nc] ;
	cout << "   A=" << fr.a[nc] << "   xo=" << fr.xo[nc] ;
	cout << "   delta= " << fr.delta[nc] << "   omega= " << fr.omega[nc] << "   k= " << fr.k[nc];
	cout << "   area= " << fr.area[nc] << "   xmedio= " << fr.xmed[nc] ;
	cout << "   sigmax=" << fr.sx[nc] << "\n";
	
	//fill tree

	//draws the fit
	logG->SetLineWidth(1.5);
	logG->Draw("same");

	if(strcmp(disp,"y")!=0)
	  logG->Delete();

	if(strcmp(disp,"y")==0)
	  c->Update();

      }
      else
      {
	// no fit: all parameters set to zero
	fr.chi2[nc]=0;
	fr.dof[nc]=0;
	fr.a[nc]=-999.;
	fr.xo[nc]=0;
	fr.delta[nc]=0;
	fr.omega[nc]=0;
	fr.k[nc]=0;
	fr.area[nc]=0;
	fr.xmed[nc]=0;
	fr.sx[nc]=0;
      }

      fr.nch[nc]=nc;
      fr.npks[nc]=npeaks;

      if(strcmp(disp,"y")==0)
	c->Update();
      //      cout << "teste - canal:" << nChannel << endl;
    }

    //cout << "teste - evento:" << i << endl;
  
    fr.nev=i;
    if(strcmp(disp,"y")==0)
      getchar();

    //fill tree
    fitres->Fill();
    cout << " *** FILL *** ";

  }
  
  if(strcmp(disp,"y")==0)
    logG->Delete();

  hsig->Delete();
  hsig1->Delete();
  f1->Close();
  AR->Delete();

  c->Close();

  //final results A PARTIR DAQUI E QUE TENHO ALTERACOES A FAZER

  cout << "\n\n\====== FINAL RESULTS ======\n";
  
  
  TCanvas *c = new TCanvas("c","Final results",10,10,900,900);
  
  pad7 = new TPad("pad7","canal 1",0.03,0.50,0.90,0.90,21);  
  pad8 = new TPad("pad8","canal 2",0.03,0.05,0.90,0.45,21);  

  pad7->Draw();
  pad8->Draw();

//////////////////////////////////////////////////////////////////////////////////

  TH1F *hamplitude1 = new TH1F("hamplitude1",Form("peak amplitude - channel %d",nChannel),50,0.,150.);   
  TH1F *hamplitude2 = new TH1F("hamplitude2",Form("peak amplitude - channel %d",nChannel),50,0.,150.);   

  TCut cut1 = "channel==0";
  TCut cut2 = "channel==3";
 
  hamplitude1->SetFillColor(2);
  pad7->cd();
  pad7->GetFrame()->SetFillColor(18);
  fitres->Draw("a >> hamplitude1",cut1);//<----------------------------------
  hamplitude1->Fit("landau");
  c->Update();

  hamplitude2->SetFillColor(2);
  pad8->cd();
  pad8->GetFrame()->SetFillColor(18);
  fitres->Draw("a >> hamplitude2",cut2);
  hamplitude2->Fit("landau");
  
  meanv1 = hamplitude1 -> GetMean();
  stdv1 = hamplitude1 -> GetRMS();

  meanv2 = hamplitude2 -> GetMean();
  stdv2 = hamplitude2 -> GetRMS();
  
  cout << "\n\n PEAK AMPLITUDE DISTRIBUTION RESULTS\n\n";

  cout << "Channel " << nChannel << " standard deviation=  " << stdv1 << "  mean value=  " <<  meanv1 << "\n"; 
  cout << "Channel " << nChannel << " standard deviation=  " << stdv2 << "  mean value=  " <<  meanv2 << "\n";
 
  c->Update();
  getchar();

  hamplitude1->Delete();
  hamplitude2->Delete();


  //getchar();

  //henergy1->Delete();
  //henergy2->Delete();

  TH1F *hdeltax = new TH1F("hdeltax","x difference - Channels 1/4", 50,-5.,5.);

  hdeltax-> SetFillColor(4);
  pad7->cd();
  pad7->GetFrame()-> SetFillColor(18);
  fitres->Draw("xmed[0]-xmed[3] >> hdeltax");

  cout << "\n\nGAUSSIAN FIT\n\n";

  hdeltax->Fit("gaus");

  c->Update();
  getchar();


  //close file
  fitres_file1->Write();
  fitres_file1->Close();

  return 0;
}
