#include <stdlib.h>
#include <iostream.h>


#include <TROOT.h>
#include <TApplication.h>
#include <TVirtualX.h>
#include <RQ_OBJECT.h>
#include <TRootEmbeddedCanvas.h>
#include <TCanvas.h>
#include <TH1.h>
#include <TH2.h>
#include <TRandom.h>
#include <TSystem.h>
#include <TSystemDirectory.h>
#include <TEnv.h>
#include <TFile.h>
#include <TKey.h>

class analiza {

 private:
  TFile *finput, *foutput;
  TPad *pad1, *pad2, *pad3, *pad4, *pad5, *pad6, *pad7, *pad8;

  //Declaration of leaves type for raw data
  Int_t           nChannel;
  Float_t         signal[256];
  Int_t           npeaks;
  Float_t         Tmed[64];
  Float_t         SigmaT[64];
  Float_t         Peak[64];
  Float_t         PeakSum[64];
  Float_t         TTrigger[64];
  Float_t         DeltaT[64];
  Float_t         sum;

  //signal analysis
  Float_t xo;                   //last channel before signal
  Float_t ttrigger,trigger;    //analysis trigger (x,y)
  Float_t tpeak,peak;          //peak (x,y)
  Float_t deltat;	      //tpeak-xo

  Int_t j;                  //auxiliary counters



  //energy calculations
  Float_t meanv1,stdv1,meanv2,stdv2;          //mean value and standard deviation for signal stats
  Float_t m1,b1,m2,b2;                        //energy parameters
  Float_t Emeanv1,Emeanv2,Estdv1,Estdv2;
  //const Float_t avgdeltae=2.335;
  // const Float_t sigmadeltae=1.004;

  //baseline
  Float_t bl;

 public:
  int a_amplitude(int nevents);
  //~a_amplitude();
};


struct fit_results{
    Int_t nev,nch[6],npks[6];                //event number, channel number and number of peaks
    Float_t chi2[6],dof[6];                  //chi square and degrees of freedom
    Float_t a[6],xo[6],delta[6],omega[6],k[6];    //fitting parameters
    Float_t area[6],xmed[6],sx[6];           //estimators (sx must be the standard deviation)
}fr;
