#include "AnalizaGUIv00.h"
//#include "AnalizaAmplitudev00.h"


//////////////////////////////////////////////////////
//
//
//          MENUS CONFIGURAO
//
//
//////////////////////////////////////////////////////



class TileFrame {

RQ_OBJECT("TileFrame")

private:
   TGCompositeFrame *fFrame;
   TGCanvas         *fCanvas;

public:
   TileFrame(const TGWindow *p);
   virtual ~TileFrame() { delete fFrame; }

   TGFrame *GetFrame() const { return fFrame; }

   void SetCanvas(TGCanvas *canvas) { fCanvas = canvas; }
   void HandleMouseWheel(Event_t *event);
};

TileFrame::TileFrame(const TGWindow *p)
{
  //Create tile view container. Used to show colormap.

   fFrame = new TGCompositeFrame(p, 10, 10, kHorizontalFrame,
                                 TGFrame::GetWhitePixel());
   fFrame->Connect("ProcessedEvent(Event_t*)", "TileFrame", this,
                "HandleMouseWheel(Event_t*)");
  fCanvas = 0;
  fFrame->SetLayoutManager(new TGTileLayout(fFrame, 8));

  gVirtualX->GrabButton(fFrame->GetId(), kAnyButton, kAnyModifier,
                       kButtonPressMask | kButtonReleaseMask |
                       kPointerMotionMask, kNone, kNone);
}

//void TileFrame::HandelMouseWheel(Event_t *event)
//{
  //Handle mouse wheel to scroll.

// if (event->fType != kButtonPress && event->fType != kButtonRelease)
//      return;

//   Int_t page = 0;
//   if (event->fCode == kButton4 || event->fCode == kButton5) {
//      if (!fCanvas) return;
//      if (fCanvas->GetContainer()->GetHeight())
//         page = Int_t(Float_t(fCanvas->GetViewPort()->GetHeight() *
//                              fCanvas->GetViewPort()->GetHeight()) /
//                              fCanvas->GetContainer()->GetHeight());
//   }

//   if (event->fCode == kButton4) {
//      //scroll up
//      Int_t newpos = fCanvas->GetVsbPosition() - page;
//      if (newpos < 0) newpos = 0;
//      fCanvas->SetVsbPosition(newpos);
//   }
//   if (event->fCode == kButton5) {
//      // scroll down
//      Int_t newpos = fCanvas->GetVsbPosition() + page;
//      fCanvas->SetVsbPosition(newpos);
//   }
  
//}

TestMainFrame::TestMainFrame(const TGWindow *p, UInt_t w, UInt_t h)
{
   // Create test main frame. A TGMainFrame is a top level window.

   fMain   = new TGMainFrame(p, w, h);
   fMain->Connect("CloseWindow()", "TestMainFrame", this, "CloseWindow()"); 
   
   // Create menubar and popup menus. The hint objects are used to place
   // and group the different menu widgets with respect to eachother.
   fMenuBarLayout = new TGLayoutHints(kLHintsTop | kLHintsLeft | kLHintsExpandX,
                                      0, 0, 1, 1);
   fMenuBarItemLayout = new TGLayoutHints(kLHintsTop | kLHintsLeft, 0, 4, 0, 0);
   fMenuBarHelpLayout = new TGLayoutHints(kLHintsTop | kLHintsRight);

   fMenuFile = new TGPopupMenu(gClient->GetRoot());
   fMenuFile->AddEntry("&Abrir...", M_FILE_OPEN);
   fMenuFile->AddEntry("&Gravar", M_FILE_SAVE);
   fMenuFile->AddEntry("G&ravar como...", M_FILE_SAVEAS);
   fMenuFile->AddEntry("&Fechar", -1);
   fMenuFile->AddSeparator();
   fMenuFile->AddEntry("&Imprimir", M_FILE_PRINT);
   fMenuFile->AddEntry("C&onfigura Impresso...", M_FILE_PRINTSETUP);
   fMenuFile->AddSeparator();
   fMenuFile->AddEntry("S&air", M_FILE_EXIT);

   fMenuFile->DisableEntry(M_FILE_SAVEAS);
   fMenuFile->HideEntry(M_FILE_PRINT);


   fMenuTest = new TGPopupMenu(gClient->GetRoot());
   fMenuTest->AddLabel("Anlise");
   fMenuTest->AddSeparator();
   fMenuTest->AddEntry("&Parmetros...", M_TEST_DLG);
 
   fMenuHelp = new TGPopupMenu(gClient->GetRoot());
   fMenuHelp->AddEntry("&Contedo", M_HELP_CONTENTS);
   fMenuHelp->AddEntry("&Pesquisa...", M_HELP_SEARCH);
   fMenuHelp->AddSeparator();
   fMenuHelp->AddEntry("&Autor", M_HELP_ABOUT);


   // Menu button messages are handled by the main frame (i.e. "this")
   // HandleMenu() method.
   fMenuFile->Connect("Activated(Int_t)", "TestMainFrame", this,
                      "HandleMenu(Int_t)");
   fMenuFile->Connect("PoppedUp()", "TestMainFrame", this, "HandlePopup()");
   fMenuFile->Connect("PoppedDown()", "TestMainFrame", this, "HandlePopdown()");
   fMenuTest->Connect("Activated(Int_t)", "TestMainFrame", this,
                      "HandleMenu(Int_t)");
   fMenuHelp->Connect("Activated(Int_t)", "TestMainFrame", this,
                      "HandleMenu(Int_t)");

   fMenuBar = new TGMenuBar(fMain, 1, 1, kHorizontalFrame);
   fMenuBar->AddPopup("&Ficheiro", fMenuFile, fMenuBarItemLayout);
   fMenuBar->AddPopup("&Configura", fMenuTest, fMenuBarItemLayout);
   fMenuBar->AddPopup("&Ajuda", fMenuHelp, fMenuBarHelpLayout);

   fMain->AddFrame(fMenuBar, fMenuBarLayout);

   // Create TGCanvas and a canvas container which uses a tile layout manager
   fCanvasWindow = new TGCanvas(fMain, 380, 240);
   fContainer = new TileFrame(fCanvasWindow->GetViewPort());
   fContainer->SetCanvas(fCanvasWindow);
   fCanvasWindow->SetContainer(fContainer->GetFrame());


   //Pixel_t blue;
   //gClient->GetColorByName("blue", blue);
   //fCanvasWindow->SetBackgroundColor(blue);

   // Fill canvas with 256 colored frames (notice that doing it this way
   // causes a memory leak when deleting the canvas (i.e. the TGFrame's and
   // TGLayoutHints are NOT adopted by the canvas).
   // Best is to create a TList and store all frame and layout pointers
   // in it. When deleting the canvas just delete contents of list.
   // for (int i=0; i < 45; ++i)
   //   fCanvasWindow->AddFrame(new TGFrame(fCanvasWindow->GetContainer(),
   //                                       32, 32, 0, (i+1)&44),
   //                           new TGLayoutHints(kLHintsExpandY | kLHintsRight));

   fMain->AddFrame(fCanvasWindow, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY,
                                                    0, 0, 0, 0));

   fMain->SetWindowName("Analiza");

   fMain->MapSubwindows();

   // we need to use GetDefault...() to initialize the layout algorithm...
   fMain->Resize();
   fMain->MapWindow();
   fMain->Print();
   Connect("Created()", "TestMainFrame", this, "Welcome()");
   Created();
}

TestMainFrame::~TestMainFrame()
{
   // Delete all created widgets.

   delete fContainer;
   delete fCanvasWindow;

   delete fMenuBarLayout;
   delete fMenuBarItemLayout;
   delete fMenuBarHelpLayout;

   delete fMenuBar;
   delete fMenuFile;
   delete fMenuTest;
   delete fMenuHelp;
   //delete fCascadeMenu;

   delete fMain;
}

void TestMainFrame::CloseWindow()
{
   // Got close message for this MainFrame. Terminates the application.

   gApplication->Terminate(0);
}


void TestMainFrame::HandleMenu(Int_t id)
{
   // Handle menu items.

   switch (id) {

      case M_FILE_OPEN:
         {
	   char *finput;
	   
            static TString dir(".");
            TGFileInfo fi;
            fi.fFileTypes = filetypes;
            fi.fIniDir    = StrDup(dir.Data());
            printf("fIniDir = %s\n", fi.fIniDir);
            new TGFileDialog(gClient->GetRoot(), fMain, kFDOpen, &fi);
            printf("Open file: %s (dir: %s)\n", fi.fFilename, fi.fIniDir);
            dir = fi.fIniDir;
	    finput=fi.fFilename;
	    TFile* myfile = new TFile(finput); 
	    cout << "File to Open ... %s" << myfile << endl;
         }
         break;

      case M_FILE_SAVE:
         printf("M_FILE_SAVE\n");
         break;

      case M_FILE_PRINT:
         printf("M_FILE_PRINT\n");
         printf("Hiding itself, select \"Print Setup...\" to enable again\n");
         fMenuFile->HideEntry(M_FILE_PRINT);
         break;

      case M_FILE_PRINTSETUP:
         printf("M_FILE_PRINTSETUP\n");
         printf("Enabling \"Print\"\n");
         fMenuFile->EnableEntry(M_FILE_PRINT);
         break;

      case M_FILE_EXIT:
         CloseWindow();   // terminate theApp no need to use SendCloseMessage()
         break;

      case M_TEST_DLG:
         new TestDialog(gClient->GetRoot(), fMain, 400, 200);
         break;

      default:
         printf("Menu item %d selected\n", id);
         break;
   }
}


TestDialog::TestDialog(const TGWindow *p, const TGWindow *main, UInt_t w,
                       UInt_t h, UInt_t options)
{
  // Create a dialog window. A dialog window pops up with respect to its
  // "main" window.
  
  // Used to store GUI elements that need to be deleted in the ctor.
  // fCleanup = new TList;


   fMain = new TGTransientFrame(p, main, w, h, options);
   fMain->Connect("CloseWindow()", "TestDialog", this, "CloseWindow()");

   //fMain->ChangeOptions((fMain->GetOptions() & ~kVerticalFrame) | kHorizontalFrame);

   f1 = new TGCompositeFrame(fMain, 60, 20, kHorizontalFrame | kFixedWidth);
   f2 = new TGCompositeFrame(fMain, 60, 20, kVerticalFrame);
   f3 = new TGCompositeFrame(f2, 60, 20, kVerticalFrame);
   f4 = new TGCompositeFrame(f2, 60, 20, kHorizontalFrame);


   fL1 = new TGLayoutHints(kLHintsTop | kLHintsExpandX | kLHintsExpandY,
			   2, 2, 3, 7);
   fL2 = new TGLayoutHints(kLHintsBottom | kLHintsRight, 2, 2, 5, 1);
   
   fL12 = new TGLayoutHints(kLHintsBottom | kLHintsCenterX | kRaisedFrame, 60, 2, 10, 1);

   //fOkButton = new TGTextButton(f1, "&Ok", 1);
   //fOkButton->Connect("Clicked()", "TestDialog", this, "DoOK()");

   fCancelButton = new TGTextButton(f1, "&Fechar", 2);
   fCancelButton->Connect("Clicked()", "TestDialog", this, "DoCancel()");


   //f1->AddFrame(fOkButton, fL1);
   //f1->Resize(150, fOkButton->GetDefaultHeight());

   f1->AddFrame(fCancelButton, fL1);   
   f1->Resize(70, fCancelButton->GetDefaultHeight());

   fMain->AddFrame(f1, fL12); 
  
   fLtitle = new TGLabel(f4,new TGString("N. de eventos a analisar ... :"));
   fTxt1 = new TGTextEntry(f4,new TGTextBuffer(50));
   fTxt1->Resize(50, fTxt1->GetDefaultHeight());
   fTxt1->GetBuffer()->GetString();
   cout << "Txt1(0)= %i" << fTxt1 << endl;

   f4->AddFrame(fLtitle,fL1);
   f4->AddFrame(fTxt1,fL1);

   f2->AddFrame(f4,fL1);

   fMain->AddFrame(f2, fL2);
  


   //--------- create radio buttons groups
   fG1 = new TGGroupFrame(f3, new TGString("Tipo de Anlise"),kVerticalFrame);//|kRaisedFrame);
   fG2 = new TGGroupFrame(f3, new TGString("Modo Grfico"),kHorizontalFrame); // | kRaisedFrame);

   fL3 = new TGLayoutHints(kLHintsTop | kLHintsLeft | kLHintsExpandX | kLHintsExpandY, 2, 2, 2, 2);
   fL4 = new TGLayoutHints(kLHintsTop | kLHintsCenterX, 2, 2, 5, 2);


   fRad0 = new TGRadioButton(fG2, "&Todos",91);
   fRad1 = new TGRadioButton(fG2, "&Nenhum",92);
   
   fG2->AddFrame(fRad0, fL4);
   fRad0->Connect("Pressed()", "TestDialog", this, "HandleButtons()");
   fG2->AddFrame(fRad1, fL4);
   fRad1->Connect("Pressed()", "TestDialog", this, "HandleButtons()");

   f3->AddFrame(fG2,fL3);

   f2->AddFrame(f3, fL3);


   fRad[0] = new TGRadioButton(fG1, new TGHotString("&amplitude"), 81);
   fRad[1] = new TGRadioButton(fG1, new TGHotString("&muo"), 82);
   fRad[2] = new TGRadioButton(fG1, new TGHotString("&gama (c/ Pb)"), 83);
   fRad[3] = new TGRadioButton(fG1, new TGHotString("&gama (s/ Pb)"), 84);
   fRad[4] = new TGRadioButton(fG1, new TGHotString("&sub-gama"), 85);
   fRad[5] = new TGRadioButton(fG1, new TGHotString("&cascata"), 86);
   
   for (int i = 0; i < 6; ++i) {
      fG1->AddFrame(fRad[i], fL3);
      fRad[i]->Connect("Pressed()", "TestDialog", this, "HandleButtons()");
   }

   f3->AddFrame(fG1, fL3);
   
   fMain->MapSubwindows();

   fMain->Resize();

   // position relative to the parent's window
   Window_t wdum;
   int ax, ay;
   gVirtualX->TranslateCoordinates(main->GetId(), fMain->GetParent()->GetId(),
             (Int_t)(((TGFrame *) main)->GetWidth() - fMain->GetWidth()) >> 1,
             (Int_t)(((TGFrame *) main)->GetHeight() - fMain->GetHeight()) >> 1,
             ax, ay, wdum);
   fMain->Move(ax, ay);

   fMain->SetWindowName("Parmetros da anlise");

   fMain->MapWindow();
   gClient->WaitFor(fMain);    // otherwise canvas contextmenu does not work
}

TestDialog::~TestDialog()
{
   // Delete test dialog widgets.

   delete fOkButton;
   delete fCancelButton;
   delete fRad[0];delete fRad[1];delete fRad[2];delete fRad[3];delete fRad[4];delete fRad[5];
   //delete fTxt1;
   delete fG1; delete fG2; delete fG3; 
   delete f1; delete f2; delete f3;delete f4;
   delete fL1; delete fL2; delete fL3; delete fL4;delete fL5; delete fL12;
     
   delete fTxt1;

   delete fMain;
}


void TestDialog::CloseWindow()
{
   // Called when window is closed via the window manager.

   delete this;
}

void TestDialog::DoOK()
{
   //fFillHistos = kFALSE;
   printf("\nTerminating dialog: OK pressed\n");

   // The same effect can be obtained by using a singleshot timer:

   TTimer::SingleShot(150, "TestDialog", this, "CloseWindow()");
}


void TestDialog::DoCancel()
{
   //fFillHistos = kFALSE;
  // printf("\nTerminating dialog: Cancel pressed\n");
  // fMain->SendCloseMessage();
   //TTimer::SingleShot(150, "TestDialog", this, "CloseWindow()");

  delete this;
}


void TestDialog::HandleButtons(Int_t id)
{
   // Handle different buttons.

   if (id == -1) {
      TGButton *btn = (TGButton *) gTQSender;
      id = btn->WidgetId();
   }

   printf("DoButton: id = %d\n", id);

   //TGButton *btn = (TGButton *) gTQSender;
   //Int_t id = btn->WidgetId();

   if (id>=81 && id<=86) {
     for (int i=0; i<7;i++)
       if(fRad[i]->WidgetId() !=id)
	 fRad[i]->SetState(kButtonUp);
   }

   switch (id){

   case 81: // amplitude
     cout << "Txt1= %i" << fTxt1 << endl;
     //a_amplitude(fTxt1);
     break;

   case 82: // muo

     break;

   case 83: // gama (c/ Pb)

     break;

   case 84: // gama (s/ Pb)
     
     break;

   case 85: // sub-gama

     break;

   case 86: // cascata

     break;

   case 91: // Todos
     fRad1->SetState(kButtonUp);
     break;

   case 92:// Nenhum
     fRad0->SetState(kButtonUp);
     break;

   default:
     break;
   }
}


void TestDialog::HandleEmbeddedCanvas(Int_t event, Int_t x, Int_t y,
                                      TObject *sel)
{
   // Handle events in the left embedded canvas.

   if (event == kButton3Down)
      printf("event = %d, x = %d, y = %d, obj = %s::%s\n", event, x, y,
             sel->IsA()->GetName(), sel->GetName());
}



